///////////////////////////////////////////////////////////////////////////////
//	Smap.googleEarth.js, 2015-02-07, 西岡 芳晴 ( NISHIOKA Yoshiharu ), 
//		GSJ.engine.googleEarth()関数
//		Google Earthラッパー
//	(未実装) 非同期が必要ない場合の処理は行っていない．
///////////////////////////////////////////////////////////////////////////////

'use strict';

( function( GSJ ) {

	if ( google ) {
		google.load( 'earth', '1' ); 
	}

	// GoogleEarth用map生成ファクトリー関数
	GSJ.engine.googleEarth = function( map ){ 

		// ライブラリ依存のmapオブジェクト作成とコントロールの初期化
		var
			promise;

		map.fov = 60; // 視野角 ( 360度法 ), 画面描画の実測値か逆算
		map.flyToSpeed = 3;
		if ( google.earth ) {
			google.load( 'earth', '1' ); 
		}
		map.promise = GSJ.promise( function( resolve, reject ) {
				function createInstance() {
					google.earth.createInstance( map.owner, 
						function( ge ){
							map.original = ge;
							map.setView( { center: map.center, zoom: map.zoom }, { animate: true } );
					      	ge.getWindow().setVisibility( true );
							resolve( map );
						},
						function() {
							reject();
						}
					);
				}

			if ( google.earth ) {
				 // すでにgoogle.earthが使用可能ならこちらを実行
				 // ライブラリユーザがsetOnLoadCallbac()をすでに使用した場合など
				createInstance();
/*
				google.setOnLoadCallback( function() {
					createInstance();
					console.log( google.earth );
				});
*/
			} else {
				google.setOnLoadCallback( function() {
					createInstance();
				} );
			}
		} );

/*
		var
			layerControl = null;

		map.original = new L.Map( map.owner, {
			center: map.center,
			minZoom: map.minZoom,
			maxZoom: map.maxZoom,
			zoom: map.zoom,
			zoomControl: false
		} );
		L.control.zoom( { position: 'bottomright' } ).addTo( map.original );
*/
		// 内部関数の実装
		map._kmlLayer = function( aLayer ) {
				var
					link = map.original.createLink( '' ),
					networkLink = map.original.createNetworkLink( '' );

			link.setHref( aLayer.url );
			networkLink.set( link, true, false );
			map.original.getFeatures().appendChild( networkLink );

/*
				google.earth.fetchKml( this.original, aLayer.url, function( object ) {
					// 今のところなぜか動作しない
					if ( !object ){
						console.log( 'KML load error : ' + aLayer.url );
					}else {
						aLayer.original = object; 
						this.original.getFeatures().appendChild( object );
					}
				} );
*/

/*			var
				attr = '<a href="' + aLayer.attribution_url
						 + '" target="_blank">' + aLayer.attribution + '</a>';

			if ( !aLayer.drawTile && !aLayer.convertTile ) {
				aLayer.original = new L.TileLayer( aLayer.url, {
					maxZoom: aLayer.maxZoom,
					attribution: attr,
					opacity: ( typeof aLayer.opacity !== 'undefined' ) ? aLayer.opacity : 1, 
				} );
			} else {
	  	  		aLayer.original = new L.TileLayer.Canvas( {
					maxZoom: aLayer.maxZoom,
					attribution: attr,
					opacity: ( typeof aLayer.opacity !== 'undefined' ) ? aLayer.opacity : 1, 
				} );
				aLayer.original.drawTile = function ( canvas, coord, zoom ) {
					coord.z = zoom; 
					if ( aLayer.drawTile ) {
						aLayer.drawTile( canvas, coord );
						if ( aLayer.convertTile ) {
							aLayer.convertTile( canvas, coord );
						}
					} else {
						GSJ.loadImage( this.getTileUrl( coord ) ).then( function( img ) {
      						canvas.getContext( '2d' ).drawImage( img, 0, 0, canvas.width, canvas.height );
							aLayer.convertTile( canvas, coord );
						} );
					}
				}
			}

			aLayer.original.getTileUrl = function( coord ) { 
				return aLayer.getTileUrl( coord );
			}
			for ( var key in aLayer ) {
				if ( aLayer.url.indexOf( '{' + key + '}' ) >= 0 ) {
					aLayer.original.options[ key ] = aLayer[ key ]; 
				}
			};
			if ( aLayer.visibility ) {
				aLayer.original.addTo( map.original );
			}

			// layerのメソッドの実装
			aLayer._redraw = function() {
				this.original.redraw();
			}
			aLayer._set = function( aKey, aValue ) {
				if ( typeof aValue !== 'undefined' ) {
					this.original.options[ aKey ] = aValue;
				}
				return this.original.options[ aKey ];
			}
			aLayer._setOpacity = function( aOpacity ){
				if ( typeof aOpacity !== 'undefined' ) {
					this.original.setOpacity( aOpacity );
					this.redraw();
				}
				return this.original.options.opacity;
			}
			aLayer._setVisibility = function( aVisibility ){
				// 2014-07-03現在，重ねる順序は無視している
				if ( typeof aVisibility !== 'undefined' ) {
					if ( map.original.hasLayer( this.original ) !== aVisibility ) {
						if ( aVisibility ) {
							map.original.addLayer( this.original );
						} else {
							map.original.removeLayer( this.original );
						}
					}
				}
				return map.original.hasLayer( this.original );
			}
*/
			return aLayer;
		}
/*
		map._on = function( aType, aHandler ){
			this.original.addEventListener( aType, function( event ) {
				var
					newEvent = {
						type: aType,
						target: event.target,
						latLng: { lat: event.latlng.lat, lng: event.latlng.lng },
						domEvent: event.originalEvent,
						original: event
					};
				if ( typeof event.latlng !== 'undefined' ) {
					newEvent.latLng = { lat: event.latlng.lat, lng: event.latlng.lng };
				}
				aHandler( newEvent );
			} );
			return this;
		}

		map._addBase = function( aLayer ) {
			for ( var i = 0; i < this.bases.length; i++ ) {
				if ( this.original.hasLayer( this.bases[ i ].original ) ) {
					this.original.removeLayer( this.bases[ i ].original );
				}
			}
			this.original.addLayer( aLayer.original, true );
			aLayer.original.bringToBack();
			if ( this.layerControl.original ) {
				this.layerControl.original.addBaseLayer( aLayer.original, aLayer.title );
			}
			return aLayer;
		};
		map._addMarker = function( aPosition, params ) {
			var
				marker = {};

			marker.original = L.marker( aPosition, params );
		  	if ( params.popup ) {
  	  			marker.original.bindPopup( params.popup );
			}
			marker.original.addTo( this.original );
			marker._closePopup = function() {
				this.original.closePopup();
			};
			marker._openPopup = function() {
				this.original.openPopup();
			};
			marker._setPopup = function( popup ) {
				if ( typeof popup !== 'undefined' ) {
					marker.popup = popup;
  	  				this.original.bindPopup( popup );
  	  			}
  	  			return marker.popup;
			};
			return marker;
		}
*/
		map._addOverlay = function( aLayer ) {
/*			if ( this.layerControl.original ) {
				var
					title = ( aLayer.title ) ? aLayer.title : 'new layer';
				this.layerControl.original.addOverlay( aLayer.original, title );
			}
			return aLayer;
*/
		};
/*
		map._addPopup = function( aLatLng, aContent ) {
			this.popup = {
				latLng: aLatLng,
				content: aContent,
				original: L.popup()
			};
	//		this.popups.push( this.popup ); //ポップアップのリストを管理する？
			this.popup.original.setLatLng( aLatLng );
			this.popup.original.setContent( aContent );
			this.popup.original.openOn( this.original );
			return this.popup;
		}
		map._delBase = function( aLayer ) {
			this.original.removeLayer( aLayer.original );
		}
		map._delMarker = function( aMarker ) {
			this.original.removeLayer( aMarker.original );
		}
		map._delOverlay = function( aLayer ) {
			this.original.removeLayer( aLayer.original );
		}
		map._delPopup = function() {
			this.original.removeLayer( this.popup.original );
		}
		map._layerControl = function( aShow ) {
		  	if ( typeof aShow === 'undefined' || aShow ) {
		  		if ( !this.layerControl.original ) {
					var
						basesList = {},
      					overlaysList = {};

				    this.bases.forEach( function( layer ) {
				    	basesList[ layer.title ] = layer.original;
					} );
				    this.overlays.forEach( function( layer ) {
				        overlaysList[ layer.title ] = layer.original;
				    } );
					this.layerControl.original = L.control.layers( basesList, overlaysList ).addTo( map.original );
				}
			} else if ( this.layerControl.original ) {
				this.layerControl.original.removeFrom( map.original );
		   		this.layerControl.original = null;
			}
		}
		map._scaleControl = function( aShow ) {
		  	if ( typeof aShow === 'undefined' || aShow ) {
		  		if ( !this.scaleControl.original ) {
//				    this.scaleControl.original = L.control.scale();
				    this.scaleControl.original = L.control.scale().addTo( map.original );
				}
			} else if ( this.scaleControl.original ) {
				this.scaleControl.original.removeFrom( map.original );
		   		this.scaleControl.original = null;
			}
		}
		map._setBase = function( aLayer ) {
			if ( typeof( aLayer ) === 'undefined' ) {
				for ( var i = 0; i < this.bases.length; i++ ) {
					if ( this.original.hasLayer( this.bases[ i ].original ) ) {
						aLayer = this.bases[ i ];
					}
				}
			} else {
				for ( var i = 0; i < this.bases.length; i++ ) {
					this.original.removeLayer( this.bases[ i ].original );
					if ( aLayer === this.bases[ i ] ) {
						this.original.addLayer( this.bases[ i ].original, true );
					}
				}
				aLayer.original.bringToBack();
				if ( layerControl !== null ) {
					layerControl.addBaseLayer( aLayer.original, aLayer.title );
				}
			}
			return aLayer;
		}
		map._setBounds = function( bounds ) {
			var
				sw, ne, b;
			
			if ( bounds ) { // undefinedでもnullでもない場合
				this.original.fitBounds( L.latLngBounds( bounds.sw, bounds.ne ) );
			}
  			b = this.original.getBounds();
  			sw = { lat: b.getSouth(), lng: b.getWest() };
  			ne = { lat: b.getNorth(), lng: b.getEast() };
    		return { sw: sw, ne: ne };
		}
*/
		map._setCenter = function( aCenter, params ) {
			var
				la = this.original.getView().copyAsLookAt( this.original.ALTITUDE_RELATIVE_TO_GROUND );
			if ( typeof aCenter !== 'undefined' ) {
				la.setLatitude( aCenter.lat );
				la.setLongitude( aCenter.lng );
				if ( typeof params !== 'undefined' && !params.animate ) {
					this.original.getOptions().setFlyToSpeed( this.original.SPEED_TELEPORT );
				}
				this.original.getView().setAbstractView( la );
				this.original.getOptions().setFlyToSpeed( this.flyToSpeed );
			} else {
				aCenter = { lat: la.getLatitude(), lng: la.getLongitude() };
			}
			return aCenter;
		}

		map._setScale = function( aScale, params ) {
			var
				la = this.original.getView().copyAsLookAt( this.original.ALTITUDE_RELATIVE_TO_GROUND );
			if ( typeof aScale !== 'undefined' ) {
				if ( typeof params !== 'undefined' && !params.animate ) {
					this.original.getOptions().setFlyToSpeed( this.original.SPEED_TELEPORT );
				}
				la.setRange( aScale * this.getRangePx() );
				this.original.getView().setAbstractView( la );
				this.original.getOptions().setFlyToSpeed( this.flyToSpeed );
			} else {
				aScale= la.getRange() / map.getRangePx();
			}
			return aScale;
		}

		map._setView = function( aView, params ) { // 結果がおかしい？
			var
				center,
				zoom,
				la = this.original.getView().copyAsLookAt( this.original.ALTITUDE_RELATIVE_TO_GROUND );
			if ( ( typeof aView !== 'undefined' ) && ( typeof aView.center !== 'undefined' ) ) {
				center = GSJ.latLng( aView.center );
				la.setLatitude( center.lat );
				la.setLongitude( center.lng );
				if ( typeof aView.zoom !== 'undefined' ) {
					la.setRange( GSJ.zoomToScale( aView.zoom, center.lat ) * this.getRangePx() );
				}
				if ( typeof params !== 'undefined' && !params.animate ) {
					this.original.getOptions().setFlyToSpeed( this.original.SPEED_TELEPORT );
				}
				this.original.getView().setAbstractView( la );
				this.original.getOptions().setFlyToSpeed( this.flyToSpeed );
			}
			la = this.original.getView().copyAsLookAt( this.original.ALTITUDE_RELATIVE_TO_GROUND );
			zoom = GSJ.scaleToZoom( la.getRange() / map.getRangePx(), la.getLatitude() );
			return { center: { lat: la.getLatitude(), lng: la.getLongitude() }, zoom: zoom };
		}

		return map;
	}

} ) ( GSJMap );
